package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 获取公告列表
 * 
 * @author puhui
 *
 */
public class announce_get extends XYZB implements API {
	public String parameter;//参数集合
	public String Description;

	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		// 获取parameter对应的内容
		Description = MapUtil.getValue("Description", data);
		
		if(Description.contains("错误token")){
			Response re = RequestDataUtils.Get_Errtoken(data, "/api/v1/announce", Client_token);
			return re;
		}else if(Description.contains("超长token")){
			Response re = RequestDataUtils.Get_Longtoken(data, "/api/v1/announce", Client_token);
			return re;
		}else if(Description.contains("无token")){
			Response re = RequestDataUtils.Get_Notoken(data, "/api/v1/announce");
			return re;
		}
		Response re = RequestDataUtils.Get_Noparameter(data, "/api/v1/announce",Client_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
				
			if((data.get("custom") != null) && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if (jp.getString("data") != null) {
				parameter = MapUtil.getValue("parameter", data);
				
				String dataarr[] =jp.getString("data.data").split("]");
				System.out.println(jp.getString("data.data"));
				
				try {
					ResultSet xyu_announcement=null;
					xyu_announcement = this.selectFromDB(
								" xyu_announcement a ",
								" a.token_room_num = '" + Current_room + "' ");
					xyu_announcement.last();
					
//					System.out.println(dataarr.length);
//					System.out.println(xyu_announcement.getRow());
						
					if (xyu_announcement.getRow()!=dataarr.length) {
						result = result && false;
						failReason = failReason + "xyu_announcement.getRow()  is not  dataarr.length;";
					} 
					
				} catch (Exception e) {
					result = result && false;
					failReason = failReason + "cannot verify xyu_announcement info in DB;";
					e.printStackTrace();
				}
			}
		}
		
		if (result){
			return "Pass";
		}else{
			return "Fail:" + failReason;
		}
	}

}
